@echo off
@setlocal enabledelayedexpansion
@setlocal

@REM ----------------------------------------------------------------------------------------------
@REM analysis_sanitizer_log
@REM
@REM explanation:
@REM    1.target dirzcmw Project fileLڂOutput Dir
@REM    2.Output Dir*.Sanitizerlogt@C
@REM        t@CL:detect_sanitizerlog_flg=ONAt@C:detect_sanitizerlog_flg=OFF
@REM    3.Sanitizer ubsan Warning 
@REM        WarningL:detect_Warning_flg=ONAWarning:detect_Warning_flg=OFF
@REM    4.WarningL *.SanitizerlogtargetKeyword𒊏o*.onlysanitizerlog𐶐
@REM
@REM argument: 
@REM    %1: target dir path
@REM    %2: targekeyword
@REM
@REM return: 
@REM    0: I
@REM    1: Error
@REM
@REM output: 
@REM    analysis result type, cmw project file name, cmw project file path, Output directory name, Output dir path, *.sanitizerlog file name, *.sanitizerlog path, Warning count
@REM
@REM    analysis result type:
@REM        12: Error              [detect_sanitizerlog_flg = OFF AND detect_Warning_flg = OFF]
@REM        11: Warning            [detect_sanitizerlog_flg = ON AND  detect_Warning_flg = ON ]
@REM        10: Success(No Warning [detect_sanitizerlog_flg = ON AND  detect_Warning_flg = OFF]
@REM         9: test csv file count in out dir
@REM         5: test csv file name in out dir
@REM         0: Warning message
@REM 
@REM    If the analysis result type is 12: 
@REM       analysis result type, cmw project file name,cmw project file path, Output directory name,Output dir path,*.sanitizerlog file name, *.sanitizerlog file path, Warning count
@REM       next row:analysis result type, cmw project file path, *.sanitizerlog file path, Keyword, error message, handle function, file name, row number, column number
@REM
@REM    If the analysis result type is 11:
@REM       analysis result type, cmw project file name,cmw project file path, Output directory name,Output dir path,*.sanitizerlog file name, *.sanitizerlog path, 0
@REM
@REM    If the analysis result type is 10:
@REM       analysis result type, cmw project file name,cmw project file path, Output directory name,Output dir  path,
@REM 
@REM ----------------------------------------------------------------------------------------------

if [%1]==[] goto :target_dir_empty
if [%2]==[] goto :targetkeyword_empty
set "target_dir=%~1"
set "targetkeyword=%~2"
goto :main

:target_dir_empty
echo ===[Error: Please input the arguments 1 argmuments target dir path 2 argmuments search keyword in analysis_sanitizer_log.bat] 1>&2
@exit /B 1

:targetkeyword_empty
set "target_dir=%~1"
if not exist "%target_dir%" (
    echo ===[Error: Please specify the arguments target dir path in analysis_sanitizer_log.bat] 1>&2
    @exit /B 1
)
echo ===[Error: Please input the arguments search keyword in analysis_sanitier_log.bat] 1>&2
@exit /B 1

:main
if not exist "%target_dir%" (
    echo ===[Error: Please specify the arguments target dir path in analysis_sanitizer_log.bat] 1>&2
    @exit /B 1
)

set bin_dir=%~dp0
for /f "usebackq delims=" %%a in (`chdir`) do set current_dir=%%a

REM target_dirz𕪐
REM search_output_dir:target_dirzcmw projectOutDir擾
for /f "usebackq tokens=1,2,3,4,5 delims=," %%a in (`call "%bin_dir%"search_output_dir.bat "!target_dir!"`) do (
    REM cmw project file name, cmw project file path, cmw project dir path, Out dir name, Out dir path
    REM echo ===[analysis_sanitizer_log][%%a / %%b / %%c / %%d / %%e] 1>&2
    set search_output_dir=%%~e
    set detect_sanitizerlog_flg=0
    set detect_warning_flg=0
    set warning_count=0

    REM echo ===[analysis_sanitizer_log][search_output_dir:!search_output_dir!] 1>&2
    if exist "!search_output_dir!" (
        REM search_sanitizerlog.bat:search_output_dirz*.sanitizerlog擾
        for /f "usebackq tokens=1 delims= eol==" %%z in (`call "%bin_dir%"search_sanitizerlog.bat "!search_output_dir!" count`) do (
            set sanitizerlog_find_count=%%z
            REM echo sanitizerlog_find_count:!sanitizerlog_find_count! 1>&2
        )
        
        echo project_block_start
        echo csv_file_block_start
        call :view_testcsv
        echo csv_file_block_end
        if !sanitizerlog_find_count! GTR 0 (
            REM search_output_dirz*.sanitizerlog0傫ꍇ
            set detect_sanitizerlog_flg=1
            REM search_output_dirz*.sanitizerlogpath擾

            for /f "usebackq tokens=1,2,3 delims=, eol==" %%i in (`call "%bin_dir%"search_sanitizerlog.bat "!search_output_dir!" content`) do (
                REM .sanitizerlog file name, sanitizerlog file path, sanitizerlog file dir path
                REM echo ===[analysis_sanitizer_log][%%i / %%j / %%k]
                set sanitizer_file_name=%%~ni
                set sanitizer_dir_path=%%~j
                set sanitizerlog_file_extension=%%~xi
                set sanitizerlog_file_path=%%~k

                REM echo ===[analysis_sanitizer_log][sanitizerlog file path:!sanitizerlog_file_path!]  1>&2
                REM echo ===[analysis_sanitizer_log][targetKeyWord:!targetKeyWord!] 1>&2
                if exist "!sanitizerlog_file_path!" (

                    REM sanitizerlogt@CtargetKeywordŌ擾
                    for /f "usebackq tokens=1,2 delims=, eol=" %%l in (`call "%bin_dir%"search_sanitizer_ubsan_warning.bat "!sanitizerlog_file_path!" "!targetKeyWord!" count`) do (
                        REM : Warning count, sanitizerlog file path
                        REM echo ===[analysis_sanitizer_log][%%l / %%m] 1>&2
                        set warning_count=%%l
                    )                    

                    if !warning_count! GTR 0 (
                        REM ʂ̌0傫ꍇ
                        set detect_warning_flg=1

                        REM targetKeyworʂ.onlysanitizerlogփ_CNg
                        call "%bin_dir%"search_sanitizer_ubsan_warning.bat "!sanitizerlog_file_path!" "!targetKeyWord!" redirect > !sanitizer_dir_path!\!sanitizer_file_name!.onlysanitizerlog

                        REM output analysis result type:Warning̏ꍇ
                        echo row_block_start
                        echo 11,%%a,%%b,%%d,"%%~e","!sanitizer_file_name!!sanitizerlog_file_extension!","!sanitizerlog_file_path!",!warning_count!
                        REM output warninge
                        for /f "usebackq tokens=1,2,3,4,5,6,7,8 delims=, eol==" %%s in (`call "%bin_dir%"search_sanitizer_ubsan_warning.bat "!sanitizerlog_file_path!" "!targetKeyWord!" content`) do (
                            REM : 0, cmw project file path, sanitizerlog file path, sanitizerlog ubsan warning, error message, handler function, file name, row, columun
                            echo 0,%%b,"!sanitizerlog_file_path!",%%s,%%t,%%u,%%v,%%w,%%x,%%y,%%z
                        )
                        echo row_block_end

                    ) else (
                        REM ʂ̌0̏ꍇ

                        REM output analysis result type:Success̏ꍇ
                        echo row_block_start
                        echo 10,%%a,%%b,%%d,"%%~e","!sanitizer_file_name!!sanitizerlog_file_extension!","!sanitizerlog_file_path!",!warning_count!
                        echo row_block_end
                    )
                )
            )

        ) else (
            REM search_output_dirz*.sanitizerlog0̏ꍇ

            REM analysis result type:Erroȑꍇ
            echo row_block_start
            echo 12,%%a,%%b,%%d,"%%~e"
            echo row_block_end
            
        )

        echo project_block_end

    ) else (
        echo ===[Error: Please specify the arguments target dir path in analysis_sanitizer_log.bat] 1>&2
        @exit /B 1
    )
)
@exit /B 0

:view_testcsv
for /f "usebackq tokens=1 delims=, eol==" %%x in (`call "%bin_dir%"search_testcsv.bat "!search_output_dir!" count`) do (
    set csv_file_count=%%x
    REM echo 9,!csv_file_count!,"!search_output_dir!"
)
for /f "usebackq tokens=1,2,3 delims=, eol==" %%m in (`call "%bin_dir%"search_testcsv.bat "!search_output_dir!" content`) do (
    REM .csv file name, csv file path, csv file dir path
    REM echo ===[analysis_sanitizer_log][%%m / %%n / %%o]
    set csv_file_name=%%~nm
    set csv_dir_path=%%~n
    set csv_file_extension=%%~xm
    set csv_file_path=%%~o
    echo 5,%%a,%%b,%%d,"%%~e","!csv_file_name!!csv_file_extension!","!csv_file_path!"
)