@echo off
@setlocal enabledelayedexpansion
@setlocal

@REM ----------------------------------------------------------------------------------------------
@REM create_report_html
@REM
@REM explanation:
@REM @@1.analysis_report pathreporthtml`ŏo
@REM
@REM argument: 
@REM     %1: analysis_report path
@REM
@REM return: 
@REM     0: I
@REM     1: Error
@REM
@REM output: 
@REM    html tag
@REM ----------------------------------------------------------------------------------------------

if [%1]==[] goto :analysis_report_empty
set "analysis_report=%~1"
goto :main

:analysis_report_empty
echo ===[Error: Please input the arguments analysis report temp in create_report_html.bat] 1>&2
@exit /B 1

:main
if not exist "%analysis_report%" (
    echo ===[Error: Please specify the arguments analysis report temp in create_report_html.bat] 1>&2
    @exit /B 1
)

REM Summary Message𐶐邽 sort /r 1sڂ擾AbZ[W𐶐
REM analysis result type=2,analysis result type=1,analysis result type=0݂ꍇAanalysis result type=2擾
REM analysis result type=1,analysis result type=0݂ꍇAanalysis result type=1擾
for /f "usebackq tokens=1,2,3,4,5,6,7 delims=," %%a in (`sort /r "%analysis_report%"`) do (
    REM analysis result type=2 or 1 or 0: analysis result type ,cmw project file neme, project full path,output dir,output dir full path, .sanitizerlog file path
    REM analysis result type=3: keyword, error message, handle function, file name, line number, column number
    REM echo ===[%%a,%%b,%%c,%%d,%%e,%%f,%%g]  1>&2

    if %%a neq 0 (
    REM analysis result type=0ȊȌꍇ(type:0͕sv̈skip)
    
        if %%a equ 12 (
            REM analysis result type Error
            set "html_h4=Error"
            set "introduction=JobW}X^[IĂȂ\܂B"
            set "intro_class_name=alert-danger"
            goto :next
        ) else if %%a equ 11 (
            REM analysis result type Warning
            set "html_h4=Warning"
            set "introduction=oꂽWarning܂"
            set "intro_class_name=alert-warning"
            goto :next
        ) else if %%a equ 10 (
            REM analysis result type Success
            set "html_h4=Success"
            set "introduction=oꂽWarning͂܂"
            set "intro_class_name=alert-success"
            goto :next
        ) else (
            REM ȊȌꍇA̍smF @review
        )
    )
)

:next
REM create html tag
set "html_doctype_tag=^<^!DOCTYPE html^>"

REM create style sheet
set "stylesheet=!stylesheet!.container {margin: 2em auto;padding: 2em 2em;background-color: white;display: grid;}"
set "stylesheet=!stylesheet!.introduction {background-color: white;font-weight: bold;}"
set "stylesheet=!stylesheet!.introduction > p {margin-top: 1em;margin-bottom: 1em;}"
set "stylesheet=!stylesheet!.header {padding-bottom: 1em;}"
set "stylesheet=!stylesheet!.header-container{margin: 1em 0;padding: 1em;background-color: #e3e3e3;}"
set "stylesheet=!stylesheet!.header-container > .col-sm {margin: 1em;}"
set "stylesheet=!stylesheet!h1 {padding: 0.25em 0.5em;color: #494949;background: transparent;border-left: solid 5px #898b8d;margin-bottom: 1em;}"
set "stylesheet=!stylesheet!.table_items {padding: 2em;background-color: #e1e1e1;font-weight: bold;}"
set "stylesheet=!stylesheet!.content_head{padding-top: 1em;padding-bottom: 1em; padding-left: 1em;background: white;border-bottom: 2px dashed #cdcdcd;}"
set "stylesheet=!stylesheet!.content_wrapper{}"
set "stylesheet=!stylesheet!.top_border{border-top: 2px dashed #cdcdcd;}"
set "stylesheet=!stylesheet!.content_item{padding-top: 1em; padding-left: 1em; background: white; word-break: break-all;}"
set "stylesheet=!stylesheet!.item{margin-bottom: 1em;background: white; font-size:0.8rem}"
set "stylesheet=!stylesheet!.table_content{padding-top: 1em; font-size:0.8rem;}"
set "stylesheet=!stylesheet!.warning_contents {padding-left: 1em;}"
set "stylesheet=!stylesheet!ul, ol {color: #1e366a;padding: 0em;}"
set "stylesheet=!stylesheet!ul li, ol li {line-height: 1.5; padding-bottom: 1em;}"
set "stylesheet=!stylesheet!.inline_location {color: cadetblue;}"
set "stylesheet=!stylesheet!.test_count {color: #e13fb7; Font-weight: bold;}"
set "stylesheet=!stylesheet!.footer {padding: 5em 0em;font-size: 15px;color: #4b5564;background: #dfdfdf}"
set "stylesheet=!stylesheet!.footer__logo {display: block;margin: 1em 1em;padding: 1em 2em;}"
set "stylesheet=!stylesheet!.footer__logo span {display: block;font-size: 14px;font-weight: 500;color: #1D8E76;}"
set "stylesheet=!stylesheet!.footer__navi {margin: 1em 1em;padding: 1em 2em;}"
set "stylesheet=!stylesheet!.footer__navi li {margin: 0;padding: 0;list-style: none;padding-left:1.2em;}"
set "stylesheet=!stylesheet!.icon {padding-right: 1em;}"
set "stylesheet=!stylesheet!.footer_wrapper {margin: 0 auto; max-width:1090px;}"
set "stylesheet=!stylesheet!@media (min-width: 768px) {.footer_wrapper {width: 100% !important;}}"

REM create html header content
(
    echo !html_doctype_tag!
    echo    ^<html lang="ja"^>
    echo    ^<head^>
    echo       ^<meta charset="Shift_JIS"^>
    echo       ^<meta name="viewport" content="width=device-width, initial-scale=1.0"^>
    echo       ^<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous"^>
    echo       ^<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.11.3/font/bootstrap-icons.min.css" integrity="sha384-XGjxtQfXaH2tnPFa9x+ruJTuLE3Aa6LhHSWRr1XeTyhezb4abCG4ccI5AkVDxqC+" crossorigin="anonymous"^>
    echo       ^<title^>Summary Sanitizer Log^</title^>
    echo       ^<style^>!stylesheet!^</style^> 
    echo    ^</head^>
    echo    ^<body^>
    echo       ^<div class="container"^>
    echo            ^<h1 class="mt-5"^>Summary Sanitizer Log^</h1^>
    echo            ^<div class="introduction"^>
    echo                ^<div class="alert %intro_class_name%" role="alert"^>
    echo                    ^<h4 class="alert-heading"^>%html_h4%^</h4^>
    echo                    ^<p^>%introduction%^</p^>
    echo                ^</div^>
    echo            ^</div^>
    echo                ^<div class="header"^>
    echo                    ^<div class="row table_items"^>
    echo                        ^<div class="col-sm-2 header_item"^>[Project Path]^</div^>
    echo                        ^<div class="col-sm-2 header_item"^>[CSV Test files]^</div^>
    echo                        ^<div class="row col-sm-8"^>
    echo                            ^<div class="col-sm-4 header_item"^>[Log File Path]^</div^>
    echo                            ^<div class="col-sm-8 header_item"^>[Content]^</div^>
    echo                        ^</div^>
    echo                    ^</div^>
    echo                ^</div^>
    echo            ^<div class="wrapper"^>

)

set row_block_flg=2
REM html content𐶐邽߁Aanalysis_report擾
for /f "usebackq tokens=1,2,3,4,5,6,7,8,9,10,11 delims=," %%a in ("%analysis_report%") do (
    REM analysis result type=2 or 1 or 0:analysis result type, cmw project file neme, project file path,output dir, output dir path,sanitizerlog file name, sanitizerlog file path, Warning count
    REM analysis result type=3: analysis result type, cmw project file neme, sanitizerlog file path, keyword, error message, handle function, file name, row number, column number
    REM echo ===[%%a,%%b,%%c,%%d,%%e,%%f,%%g,%%h,%%i,%%j,%%k] 1>&2
    set csv_file_block_flg=2
    
    REM cmwvWFNgJn̏ꍇ
    if "%%a"=="project_block_start" (
        set project_block_flg=1
        set row_content=
        set out_put_html=
        set row_html_part2=
        set csv_files_name=
        set log_file_path_content=
        set row_count=0
        REM echo ===[project block start] 1>&2
    )

    REM cmwvWFNgȈꍇ
    if "%%a"=="project_block_end" (
        set project_block_flg=0
        REM echo ===[project block end] 1>&2
    )

    REM subN(result_type:12,11,10,0)Jn̏ꍇ
    if "%%a"=="row_block_start" (
        set row_block_flg=1
        REM echo ===[row_block_start] 1>&2
    )

    REM subN(result_type:12,11,10,0)Ȉꍇ
    if "%%a"=="row_block_end" (
        set row_block_flg=0
        REM echo ===[row_block_end] 1>&2
    )

    REM CSV filef[^Jn̏ꍇ
    if "%%a"=="csv_file_block_start" (
        set csv_file_block_flg=1
        REM echo ===[csv_file_block_start] 1>&2
    )

    REM CSV filef[^Ȉꍇ
    if "%%a"=="csv_file_block_end" (
        set csv_file_block_flg=0
        REM echo ===[csv_file_block_end] 1>&2
    )

    REM ϐZbg
    if %%a equ 0 (
        REM analysis result type Warnings̏ꍇ
        set error_message=%%~f
        set handle_function=%%~g
        set test_count=%%~d
        set file_name=%%~h
        set line=%%~i
        set column=%%~j
        set function_name=%%~k
    )

    if %%a equ 5 (
        REM test csv=5̏ꍇ
        set csv_file_name=%%~f
        set csv_file_path=%%~g
    )

    if %%a leq 12 (
        REM analysis result type=12ȉ̏ꍇ
        if %%a geq 10 (
            REM analysis result type=10ȏ̏ꍇ
            set result_type=%%a
            set cmw_project_file_name=%%~b
            set cmw_project_file_path=%%~c
            set output_dir=%%~d
            set output_dir_path=%%~e
            set sanitizerlog_file_name=%%~f
            set sanitizerlog_file_path=%%~g
            set warning_count_messge=%%h
        )        
    )


    REM eprojectSummary message𐶐
    if %%a equ 12 (
        REM analysis result type Error ̏ꍇ @review
        set "log_meg=JobW}X^[IĂȂ\܂"
        set "leg_meg_class=alert-danger"
    ) else if %%a equ 11 (
        REM analysis result type Warning ̏ꍇ
        set "log_meg=oꂽWarning!warning_count_messge!܂"
        set "leg_meg_class=alert-warning"
    ) else if %%a equ 10 (
        REM analysis result type Success ̏ꍇ @review
        set "log_meg=oꂽWarning͂܂"
        set "leg_meg_class=alert-success"
    ) else if %%a equ 5 (
        REM test csv files̏ꍇAskip
    ) else if %%a equ 0 (
        REM analysis result type warnings̏ꍇAskip
    ) else if "%%a"=="project_block_start" (
        REM start s̏ꍇAskip
    ) else if "%%a"=="project_block_end" (
        REM end s̏ꍇAskip
    ) else if "%%a"=="row_block_start" (
        REM start s̏ꍇAskip
    ) else if "%%a"=="row_block_end" (
        REM start s̏ꍇAskip
    ) else if "%%a"=="csv_file_block_start" (
        REM start s̏ꍇAskip
    ) else if "%%a"=="csv_file_block_end" (
        REM end s̏ꍇAskip
    ) else (
        REM ȊO @review
        echo ===[Error: Unknown parameter: %%a in create_report_html.bat] 1>&2
        @exit /B 1
    )
    
    REM eprojectcontent𐶐
    if !project_block_flg! equ 1 (

        REM CSV Filef[^̐
        if %%a equ 5 (
            REM test csv files̏ꍇ
            set csv_files_html=!csv_files_html!^<li^>^<a href="!csv_file_path!" target="_blank"^>[!csv_file_name!]^</a^>^</li^>
            set /a csv_file_count+=1
        )
        if !csv_file_block_flg! equ 0 (
            REM CSV Filef[^end_csvfilef[^
            if !csv_file_count! equ 0 (
                set csv_files_html=!csv_files_html! CSVt@C͂܂
            ) else (
                set csv_files_html=!csv_files_html!
            )
        )

        if !row_block_flg! equ 1 (
            REM s̊Jn^O𐶐

            if %%a equ 12 (
                REM analysis result type Error ̏ꍇ
                set /a row_count+=1
                if !row_count! equ 1 (
                    set row=!row!^<div class="row table_content top_border"^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>!cmw_project_file_path!^</div^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>^<ul^>!csv_files_html!^</ul^>^</div^>
                    set row=!row!   ^<div class="row col-sm-8 content_item"^>
                ) else (
                    set row=!row!^<div class="row table_content"^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>^</div^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>^</div^>
                    set row=!row!   ^<div class="row col-sm-8 content_item top_border"^>
                )
                set row=!row!       ^<div class="col-sm-4 item"^>            
                set row=!row!           ^<a href="!output_dir_path!" target="_blank"^>[!output_dir_path!]^</a^>
                set row=!row!       ^</div^>

            ) else if %%a equ 11 (
                REM analysis result type Warning ̏ꍇ
                set /a row_count+=1
                if !row_count! equ 1 (
                    set row=!row!^<div class="row table_content top_border"^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>!cmw_project_file_path!^</div^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>^<ul^>!csv_files_html!^</ul^>^</div^>
                    set row=!row!   ^<div class="row col-sm-8 content_item"^>
                ) else (
                    set row=!row!^<div class="row table_content"^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>^</div^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>^</div^>
                    set row=!row!   ^<div class="row col-sm-8 content_item top_border"^>
                )
                set row=!row!       ^<div class="col-sm-4 item"^>
                set row=!row!           ^<a href="!output_dir_path!" target="_blank"^>[!output_dir_path!\!sanitizerlog_file_name!]^</a^>
                set row=!row!       ^</div^>

            ) else if %%a equ 10 (
                REM analysis result type Success ̏ꍇ
                set /a row_count+=1
                if !row_count! equ 1 (
                    set row=!row!^<div class="row table_content top_border"^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>!cmw_project_file_path!^</div^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>^<ul^>!csv_files_html!^</ul^>^</div^>
                    set row=!row!   ^<div class="row col-sm-8 content_item"^>
                ) else (
                    set row=!row!^<div class="row table_content"^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>^</div^>
                    set row=!row!   ^<div class="col-sm-2 content_item"^>^</div^>
                    set row=!row!   ^<div class="row col-sm-8 content_item top_border"^>
               )
                set row=!row!       ^<div class="col-sm-4 item"^>            
                set row=!row!           ^<a href="!output_dir_path!" target="_blank"^>[!output_dir_path!\!sanitizerlog_file_name!]^</a^>
                set row=!row!       ^</div^>
            )

            if %%a equ 0 (
            REM warnings̏ꍇ                
                (
                    set warning_contents=!warning_contents!^<li^>
                    set warning_contents=!warning_contents!^<span class="test_count"^>Test Case:!test_count!^</span^>
                    set warning_contents=!warning_contents!^<span class="inline_error"^>!error_message!^</span^>
                    set warning_contents=!warning_contents!^<span class="inline_location"^> !file_name! line:!line! column:!column!^</span^>
                    set warning_contents=!warning_contents!^</li^>
                )
            )
        )

        REM s̏I^O𐶐
        if !row_block_flg! equ 0 (

            (
                set row=!row!       ^<div class="col-sm-8 item"^>
                set row=!row!           ^<div class="alert !leg_meg_class!" role="alert"^>!log_meg!^</div^>
                set row=!row!           ^<div class="warning_contents"^>^<ul^>!warning_contents!^</ul^>^</div^>
                set row=!row!       ^</div^>
                set row=!row!   ^</div^>
                set row=!row!^</div^>
            )
            echo !row!
            set row=
            set warning_contents=
        )
    )

    if !project_block_flg! equ 0 (
        set row_block_flg=2
        set csv_file_count=0
        set csv_files_html=
    )
)

REM create close html content
(
    echo        ^</div^>
    echo    ^</div^>
    echo    ^<footer class="footer"^>
    echo       ^<div^ class="footer_wrapper"^>
    echo            ^<div class="md-flex md-justify-between"^>
    echo               ^<a href="https://www.gaio.co.jp/" target="_blank" class="footer__logo"^>
    echo                   ^<img src="https://www.gaio.co.jp/wp-content/themes/gaio_theme/assets/img/common/gaio_logo.png" width="92" height="46" alt="KCIeNmW[" /^>
    echo                   ^<span^>KCIEeNmW[^</span^>
    echo               ^</a^>
    echo                ^<ul class="footer__navi flex"^>
    echo                    ^<li^>^<i class="bi bi-link icon"^>^</i^>^<a href="https://llvm.org/" target="_blank"^>LLVM Project^</a^>^</li^>
    echo                    ^<li^>^<i class="bi bi-link icon"^>^</i^>^<a href="https://clang.llvm.org/docs/index.html" target="_blank"^>clang documentation^</a^>^</li^>
    echo                    ^<li^>^<i class="bi bi-github icon"^>^</i^>^<a href="https://github.com/llvm/llvm-project" class="link" target="_blank"^>llvm-project^</a^>^<^/li^>
    echo                ^</ul^>
    echo            ^</div^>
    echo        ^</div^>
    echo    ^</footer^>    
    echo    ^<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/js/bootstrap.bundle.min.js" integrity="sha384-geWF76RCwLtnZ8qwWowPQNguL3RmwHVBC9FhGdlKrxdiJJigb/j/68SIy3Te4Bkz" crossorigin="anonymous"^>^</script^>
    echo ^</body^>
    echo ^</html^>
) 
@exit /B 0


